#ifndef __APPLICATION_H__
#define __APPLICATION_H__

#include "gamewindowwin.h"
#include "renderer.h"
#include "util.h"

class Application {
	GameWindowWin &window;
	Renderer &renderer;
	Vertex vtx[4];
	Float4x4 matrix;
	ScreenLayer layer;

protected:
	virtual bool initialize() {
		// \[X쐬
		Vertex v[4] = {
			{-10.0f, -10.0f, 0.0f, 0xffe0e060},
			{-10.0f,  10.0f, 0.0f, 0xffe0e060},
			{ 10.0f, -10.0f, 0.0f, 0xffe0e060},
			{ 10.0f,  10.0f, 0.0f, 0xffe0e060},
		};
		memcpy(vtx, v, sizeof(Vertex) * 4);

		float m[16] = {
			1.0f, 0.0f, 0.0f, 0.0f,
			0.0f, 1.0f, 0.0f, 0.0f,
			0.0f, 0.0f, 1.0f, 0.0f,
			0.2f, 0.4f, 0.0f, 1.0f
		};
		memcpy(matrix.v, m, sizeof(float) * 16);

		// r[s쐬
		layer.setView(Util::lookAtLH(Float3(0.0f, 0.0f, 0.0f), Float3(0.0f, 10.0f, -40.0f), Float3(0.0f, 1.0f, 0.0f)));

		// ˉeϊs쐬
		layer.setProj(Util::perspLH(Util::toRad(40.0f), 640.0f, 480.0f, 1.0f, 500.0f));
		return true;
	}

	virtual void terminate() {
		renderer.terminate();
		window.terminate();
	}

public:
	Application(GameWindowWin &window, Renderer &renderer) : window(window), renderer(renderer) {}

	// AvJn
	int run() {
		if (!initialize())
			return -1;

		// EBhE\
		window.show();

		// bZ[W [v
		MSG msg;
		do{
			if( PeekMessage(&msg, NULL, 0, 0, PM_REMOVE) ){
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			} else {
				renderer.begin();
				renderer.render(vtx, 4, 2, matrix, layer);
				renderer.swap();
				renderer.end();
			}
		}while( msg.message != WM_QUIT );

		// e㏈
		terminate();

		return 0;
	}
};

#endif
